---------------------
PatchSet 1618 
Date: 2005/08/26 20:28:41
Author: dwsquid
Branch: squid3-icap
Tag: (none) 
Log:
apply /usr/local/bin/astyle -cs4 -O --break-blocks -l

Members: 
	src/ChunkedCodingParser.cc:1.1.2.2->1.1.2.3 
	src/ChunkedCodingParser.h:1.1.2.1->1.1.2.2 
	src/HttpReply.cc:1.21.4.2->1.21.4.3 
	src/HttpReply.h:1.8.10.2->1.8.10.3 
	src/HttpStatusLine.cc:1.3.12.1->1.3.12.2 
	src/HttpStatusLine.h:1.1.16.1->1.1.16.2 
	src/ICAPAnchor.cc:1.1.2.18->1.1.2.19 
	src/ICAPAnchor.h:1.1.2.6->1.1.2.7 
	src/ICAPClient.cc:1.1.2.5->1.1.2.6 
	src/ICAPClient.h:1.1.2.4->1.1.2.5 
	src/ICAPServiceRep.cc:1.1.2.1->1.1.2.2 
	src/ICAPServiceRep.h:1.1.2.1->1.1.2.2 
	src/ICAPXaction.cc:1.1.2.12->1.1.2.13 
	src/ICAPXaction.h:1.1.2.7->1.1.2.8 
	src/MemBuf.cc:1.6.8.4->1.6.8.5 
	src/MemBuf.h:1.3.16.5->1.3.16.6 
	src/MsgPipe.cc:1.1.2.7->1.1.2.8 
	src/MsgPipe.h:1.1.2.4->1.1.2.5 
	src/MsgPipeData.h:1.1.2.6->1.1.2.7 
	src/MsgPipeEnd.h:1.1.2.1->1.1.2.2 
	src/MsgPipeSink.h:1.1.2.2->1.1.2.3 
	src/MsgPipeSource.h:1.1.2.2->1.1.2.3 
	src/Packer.cc:1.2.14.1->1.2.14.2 
	src/Parsing.cc:1.1.12.1->1.1.12.2 
	src/StoreIOBuffer.h:1.4.12.2->1.4.12.3 
	src/TextException.cc:1.1.2.2->1.1.2.3 
	src/TextException.h:1.1.2.1->1.1.2.2 
	src/client_side_reply.cc:1.61.2.3->1.61.2.4 
	src/http.cc:1.49.2.18->1.49.2.19 
	src/http.h:1.11.4.7->1.11.4.8 
	src/store.cc:1.27.8.4->1.27.8.5 

Index: squid3/src/ChunkedCodingParser.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/Attic/ChunkedCodingParser.cc,v
retrieving revision 1.1.2.2
retrieving revision 1.1.2.3
diff -u -r1.1.2.2 -r1.1.2.3
--- squid3/src/ChunkedCodingParser.cc	26 Aug 2005 20:24:13 -0000	1.1.2.2
+++ squid3/src/ChunkedCodingParser.cc	26 Aug 2005 20:28:41 -0000	1.1.2.3
@@ -9,195 +9,224 @@
 ChunkedCodingParser::Step ChunkedCodingParser::psTrailer = &ChunkedCodingParser::parseTrailer;
 ChunkedCodingParser::Step ChunkedCodingParser::psMessageEnd = &ChunkedCodingParser::parseMessageEnd;
 
-ChunkedCodingParser::ChunkedCodingParser() {
-	reset();
+ChunkedCodingParser::ChunkedCodingParser()
+{
+    reset();
 }
 
-void ChunkedCodingParser::reset() {
-	theStep = psChunkBeg;
-	theChunkSize = theLeftBodySize = 0;
-	doNeedMoreData = false;
-	sawIeof = false;
-	theIn = theOut = NULL;
+void ChunkedCodingParser::reset()
+{
+    theStep = psChunkBeg;
+    theChunkSize = theLeftBodySize = 0;
+    doNeedMoreData = false;
+    sawIeof = false;
+    theIn = theOut = NULL;
 }
 
-bool ChunkedCodingParser::parse(MemBuf *rawData, MemBuf *parsedContent) {
-	Must(rawData && parsedContent);
-	theIn = rawData;
-	theOut = parsedContent;
+bool ChunkedCodingParser::parse(MemBuf *rawData, MemBuf *parsedContent)
+{
+    Must(rawData && parsedContent);
+    theIn = rawData;
+    theOut = parsedContent;
 
-	doNeedMoreData = !theIn->hasContent();
+    doNeedMoreData = !theIn->hasContent();
 
-	while (mayContinue()) {
-		(this->*theStep)();
-	}
+    while (mayContinue()) {
+        (this->*theStep)();
+    }
 
-	return theStep == psMessageEnd;
+    return theStep == psMessageEnd;
 }
 
-bool ChunkedCodingParser::needsMoreData() const {
-	return doNeedMoreData;
+bool ChunkedCodingParser::needsMoreData() const
+{
+    return doNeedMoreData;
 }
 
-bool ChunkedCodingParser::mayContinue() const {
-	return !doNeedMoreData && theStep != psMessageEnd;
+bool ChunkedCodingParser::mayContinue() const
+{
+    return !doNeedMoreData && theStep != psMessageEnd;
 }
 
-void ChunkedCodingParser::parseChunkBeg() {
-	Must(theChunkSize <= 0); // Should(), really
+void ChunkedCodingParser::parseChunkBeg()
+{
+    Must(theChunkSize <= 0); // Should(), really
 
-	size_t crlfBeg = 0;
-	size_t crlfEnd = 0;
-	if (findCrlf(crlfBeg, crlfEnd)) {
-		debugs(99,5, "found chunk-size end: " << crlfBeg << "-" << crlfEnd);
-		int size = -1;
-		const char *p = 0;
-		if (StringToInt(theIn->content(), size, &p, 16)) {
-			if (size < 0) {
-				throw TexcHere("negative chunk size");
-				return;
-			}
-			// check for ieof chunk extension in the last-chunk
-			if (size == 0 && p && *p++ == ';') {
-				const char *e = theIn->content() + crlfBeg; // end of extension
-				while (p < e && isspace(*p)) ++p; // skip space
-				sawIeof = e - p >= 4 &&
-					strncmp(p, "ieof", 4) == 0 &&
-					isspace(p[4]);
-			}
-			theIn->consume(crlfEnd);
-			theChunkSize = theLeftBodySize = size;
-			debugs(99,5, "found chunk: " << theChunkSize);
-			theStep = theChunkSize == 0 ? psTrailer : psChunkBody;
-			return;
-		}
-		throw TexcHere("corrupted chunk size");
-	}
-	doNeedMoreData = true;
+    size_t crlfBeg = 0;
+    size_t crlfEnd = 0;
+
+    if (findCrlf(crlfBeg, crlfEnd)) {
+        debugs(99,5, "found chunk-size end: " << crlfBeg << "-" << crlfEnd);
+        int size = -1;
+        const char *p = 0;
+
+        if (StringToInt(theIn->content(), size, &p, 16)) {
+            if (size < 0) {
+                throw TexcHere("negative chunk size");
+                return;
+            }
+
+            // check for ieof chunk extension in the last-chunk
+            if (size == 0 && p && *p++ == ';') {
+                const char *e = theIn->content() + crlfBeg; // end of extension
+
+                while (p < e && isspace(*p))
+                    ++p; // skip space
+
+                sawIeof = e - p >= 4 &&
+                          strncmp(p, "ieof", 4) == 0 &&
+                          isspace(p[4]);
+            }
+
+            theIn->consume(crlfEnd);
+            theChunkSize = theLeftBodySize = size;
+            debugs(99,5, "found chunk: " << theChunkSize);
+            theStep = theChunkSize == 0 ? psTrailer : psChunkBody;
+            return;
+        }
+
+        throw TexcHere("corrupted chunk size");
+    }
+
+    doNeedMoreData = true;
 }
 
-void ChunkedCodingParser::parseChunkBody() {
-	Must(theLeftBodySize > 0); // Should, really
+void ChunkedCodingParser::parseChunkBody()
+{
+    Must(theLeftBodySize > 0); // Should, really
 
-	const size_t parsedSize = XMIN(theLeftBodySize, (size_t)theIn->contentSize());
+    const size_t parsedSize = XMIN(theLeftBodySize, (size_t)theIn->contentSize());
 
-	theOut->append(theIn->content(), parsedSize);
-	theIn->consume(parsedSize);
-	theLeftBodySize -= parsedSize;
+    theOut->append(theIn->content(), parsedSize);
+    theIn->consume(parsedSize);
+    theLeftBodySize -= parsedSize;
 
-	if (theLeftBodySize == 0)
-		theStep = psChunkEnd;
-	else
-		doNeedMoreData = true;
+    if (theLeftBodySize == 0)
+        theStep = psChunkEnd;
+    else
+        doNeedMoreData = true;
 }
 
-void ChunkedCodingParser::parseChunkEnd() {
-	Must(theLeftBodySize == 0); // Should(), really
+void ChunkedCodingParser::parseChunkEnd()
+{
+    Must(theLeftBodySize == 0); // Should(), really
+
+    size_t crlfBeg = 0;
+    size_t crlfEnd = 0;
+
+    if (findCrlf(crlfBeg, crlfEnd)) {
+        if (crlfBeg != 0) {
+            throw TexcHere("found data bewteen chunk end and CRLF");
+            return;
+        }
 
-	size_t crlfBeg = 0;
-	size_t crlfEnd = 0;
-	if (findCrlf(crlfBeg, crlfEnd)) {
-		if (crlfBeg != 0) {
-			throw TexcHere("found data bewteen chunk end and CRLF");
-			return;
-		}
-		theIn->consume(crlfEnd);
-		theChunkSize = 0; // done with the current chunk
-		theStep = psChunkBeg;
-		return;
-	}
-	
-	doNeedMoreData = true;
+        theIn->consume(crlfEnd);
+        theChunkSize = 0; // done with the current chunk
+        theStep = psChunkBeg;
+        return;
+    }
+
+    doNeedMoreData = true;
 }
 
-void ChunkedCodingParser::parseTrailer() {
-	Must(theChunkSize == 0); // Should(), really
+void ChunkedCodingParser::parseTrailer()
+{
+    Must(theChunkSize == 0); // Should(), really
 
-	while (mayContinue())
-		parseTrailerHeader();
+    while (mayContinue())
+        parseTrailerHeader();
 }
 
-void ChunkedCodingParser::parseTrailerHeader() {
-	size_t crlfBeg = 0;
-	size_t crlfEnd = 0;
-	if (findCrlf(crlfBeg, crlfEnd)) {
-		if (crlfBeg > 0)
-			; //theTrailer.append(theIn->content(), crlfEnd);
+void ChunkedCodingParser::parseTrailerHeader()
+{
+    size_t crlfBeg = 0;
+    size_t crlfEnd = 0;
+
+    if (findCrlf(crlfBeg, crlfEnd)) {
+        if (crlfBeg > 0)
+
+            ; //theTrailer.append(theIn->content(), crlfEnd);
 
-		theIn->consume(crlfEnd);
+        theIn->consume(crlfEnd);
 
-		if (crlfBeg == 0)
-			theStep = psMessageEnd;
+        if (crlfBeg == 0)
+            theStep = psMessageEnd;
 
-		return;
-	}
+        return;
+    }
 
-	doNeedMoreData = true;
+    doNeedMoreData = true;
 }
 
-void ChunkedCodingParser::parseMessageEnd() {
-	// termination step, should not be called
-	Must(false); // Should(), really
+void ChunkedCodingParser::parseMessageEnd()
+{
+    // termination step, should not be called
+    Must(false); // Should(), really
 }
 
 // finds next CRLF
-bool ChunkedCodingParser::findCrlf(size_t &crlfBeg, size_t &crlfEnd) {
-	// XXX: This code was copied, with permission, from another software.
-	// There is a similar and probably better code inside httpHeaderParse
+bool ChunkedCodingParser::findCrlf(size_t &crlfBeg, size_t &crlfEnd)
+{
+    // XXX: This code was copied, with permission, from another software.
+    // There is a similar and probably better code inside httpHeaderParse
     // but it seems difficult to isolate due to parsing-unrelated bloat.
-	// Such isolation should probably be done before this class is used
-	// for handling of traffic "more external" than ICAP.
+    // Such isolation should probably be done before this class is used
+    // for handling of traffic "more external" than ICAP.
 
     const char *buf = theIn->content();
-	size_t size = theIn->contentSize();
+    size_t size = theIn->contentSize();
 
-	ssize_t crOff = -1;
-	bool quoted = false;
-	bool slashed = false;
-	for (size_t i = 0; i < size; ++i) {
-		if (slashed) {
-			slashed = false;
-			continue;
-		}
-
-		const char c = buf[i];
-
-		// handle quoted strings
-		if (quoted) {
-			if (c == '\\')
-				slashed = true;
-			else
-			if (c == '"')
-				quoted = false;
-			continue;
-		} else
-		if (c == '"') {
-			quoted = true;
-			crOff = -1;
-			continue;
-		}
-
-		if (crOff < 0) { // looking for the first CR or LF
-			if (c == '\n') {
-				crlfBeg = i;
-				crlfEnd = ++i;
-				return true;
-			}
-
-			if (c == '\r')
-				crOff = i;
-		} else { // skipping CRs, looking for the first LF
-			if (c == '\n') {
-				crlfBeg = crOff;
-				crlfEnd = ++i;
-				return true;
-			}
-
-			if (c != '\r')
-				crOff = -1;
-		}
-	}
+    ssize_t crOff = -1;
+    bool quoted = false;
+    bool slashed = false;
+
+    for (size_t i = 0; i < size; ++i) {
+        if (slashed) {
+            slashed = false;
+            continue;
+        }
+
+        const char c = buf[i];
+
+        // handle quoted strings
+        if (quoted) {
+            if (c == '\\')
+                slashed = true;
+            else
+                if (c == '"')
+                    quoted = false;
+
+            continue;
+        } else
+            if (c == '"') {
+                quoted = true;
+                crOff = -1;
+                continue;
+            }
+
+        if (crOff < 0) { // looking for the first CR or LF
+
+            if (c == '\n') {
+                crlfBeg = i;
+                crlfEnd = ++i;
+                return true;
+            }
+
+            if (c == '\r')
+                crOff = i;
+        } else { // skipping CRs, looking for the first LF
+
+            if (c == '\n') {
+                crlfBeg = crOff;
+                crlfEnd = ++i;
+                return true;
+            }
+
+            if (c != '\r')
+                crOff = -1;
+        }
+    }
 
-	return false;
+    return false;
 }
 
Index: squid3/src/ChunkedCodingParser.h
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/Attic/ChunkedCodingParser.h,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.2
diff -u -r1.1.2.1 -r1.1.2.2
--- squid3/src/ChunkedCodingParser.h	24 Aug 2005 05:39:22 -0000	1.1.2.1
+++ squid3/src/ChunkedCodingParser.h	26 Aug 2005 20:28:41 -0000	1.1.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ChunkedCodingParser.h,v 1.1.2.1 2005/08/24 05:39:22 rousskov Exp $
+ * $Id: ChunkedCodingParser.h,v 1.1.2.2 2005/08/26 20:28:41 dwsquid Exp $
  * 
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
  * ----------------------------------------------------------
@@ -37,52 +37,53 @@
 
 // ChunkedCodingParser is an incremental parser for chunked transfer coding
 // used by HTTP and ICAP. The parser shovels content bytes from the raw
-// input buffer into the content output buffer, both caller-supplied. 
-// Ignores chunk extensions except for ICAP's ieof. 
+// input buffer into the content output buffer, both caller-supplied.
+// Ignores chunk extensions except for ICAP's ieof.
 // Has a trailer-handling placeholder.
 
 class ChunkedCodingParser
 {
+
 public:
-	ChunkedCodingParser();
+    ChunkedCodingParser();
 
-	void reset();
+    void reset();
 
-	// true = complete success; false == needs more data
-	bool parse(MemBuf *rawData, MemBuf *parsedContent); // throws on error
+    // true = complete success; false == needs more data
+    bool parse(MemBuf *rawData, MemBuf *parsedContent); // throws on error
 
-	bool needsMoreData() const;
-	bool sawIeof; // saw ieof chunk extension after a 0-size chunk
+    bool needsMoreData() const;
+    bool sawIeof; // saw ieof chunk extension after a 0-size chunk
 
 private:
-	typedef void (ChunkedCodingParser::*Step)();
+    typedef void (ChunkedCodingParser::*Step)();
 
 private:
-	bool mayContinue() const;
+    bool mayContinue() const;
 
-	void parseChunkBeg();
-	void parseChunkBody();
-	void parseChunkEnd();
-	void parseTrailer();
-	void parseTrailerHeader();
-	void parseMessageEnd();
+    void parseChunkBeg();
+    void parseChunkBody();
+    void parseChunkEnd();
+    void parseTrailer();
+    void parseTrailerHeader();
+    void parseMessageEnd();
 
-	bool findCrlf(size_t &crlfBeg, size_t &crlfEnd);
+    bool findCrlf(size_t &crlfBeg, size_t &crlfEnd);
 
 private:
-	static Step psChunkBeg;
-	static Step psChunkBody;
-	static Step psChunkEnd;
-	static Step psTrailer;
-	static Step psMessageEnd;
-
-	MemBuf *theIn;
-	MemBuf *theOut;
-
-	Step theStep;
-	size_t theChunkSize;
-	size_t theLeftBodySize;
-	bool doNeedMoreData;
+    static Step psChunkBeg;
+    static Step psChunkBody;
+    static Step psChunkEnd;
+    static Step psTrailer;
+    static Step psMessageEnd;
+
+    MemBuf *theIn;
+    MemBuf *theOut;
+
+    Step theStep;
+    size_t theChunkSize;
+    size_t theLeftBodySize;
+    bool doNeedMoreData;
 };
 
 #endif /* SQUID_CHUNKEDCODINGPARSER_H */
Index: squid3/src/HttpReply.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/HttpReply.cc,v
retrieving revision 1.21.4.2
retrieving revision 1.21.4.3
diff -u -r1.21.4.2 -r1.21.4.3
--- squid3/src/HttpReply.cc	25 Aug 2005 21:09:55 -0000	1.21.4.2
+++ squid3/src/HttpReply.cc	26 Aug 2005 20:28:41 -0000	1.21.4.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpReply.cc,v 1.21.4.2 2005/08/25 21:09:55 rousskov Exp $
+ * $Id: HttpReply.cc,v 1.21.4.3 2005/08/26 20:28:41 dwsquid Exp $
  *
  * DEBUG: section 58    HTTP Reply (Response)
  * AUTHOR: Alex Rousskov
@@ -74,7 +74,7 @@
 void
 httpReplyInitModule(void)
 {
-	assert(HTTP_STATUS_NONE == 0); // HttpReply::parse() interface assumes that
+    assert(HTTP_STATUS_NONE == 0); // HttpReply::parse() interface assumes that
     httpHeaderMaskInit(&Denied304HeadersMask, 0);
     httpHeaderCalcMask(&Denied304HeadersMask, (const int *) Denied304HeadersArr, countof(Denied304HeadersArr));
 }
@@ -117,14 +117,14 @@
 void
 httpReplyReset(HttpReply * rep)
 {
-	// reset should not reset the protocol; could have made protoPrefix a
-	// virtual function instead, but it is not clear whether virtual methods
-	// are allowed with MEMPROXY_CLASS() and whether some cbdata void*
-	// conversions are not going to kill virtual tables
-	const String pfx = rep->protoPrefix;
+    // reset should not reset the protocol; could have made protoPrefix a
+    // virtual function instead, but it is not clear whether virtual methods
+    // are allowed with MEMPROXY_CLASS() and whether some cbdata void*
+    // conversions are not going to kill virtual tables
+    const String pfx = rep->protoPrefix;
     httpReplyClean(rep);
     *rep = HttpReply();
-	rep->protoPrefix = pfx;
+    rep->protoPrefix = pfx;
 }
 
 /* absorb: copy the contents of a new reply to the old one, destroy new one */
@@ -604,64 +604,71 @@
 // negative return is the negated HTTP_ error code
 // zero return means need more data
 // positive return is the size of parsed headers
-bool HttpReply::parse(MemBuf *buf, bool eof, http_status *error) {
-	assert(error);
-	*error = HTTP_STATUS_NONE;
-
-	// httpReplyParseStep() and debugging require 0-termination, unfortunately
-	buf->terminate(); // does not affect content size
-
-	// quick check that the response starts with HTTP/ or similar
-	// TODO: Remove? Are we optimizing an unusual case or obscure security?
-	if (buf->contentSize() >= protoPrefix.size() &&
-		protoPrefix.cmp(buf->content(), protoPrefix.size()) != 0) {
-		debugs(58, 3, "HttpReply::parse: missing protocol prefix (" <<
-			protoPrefix.buf() << ") in '" << buf->content() << "'");
-		*error = HTTP_INVALID_HEADER;
-		return false;
-	}
-
-	// find the end of headers
-	// TODO: Remove? httpReplyParseStep() should do similar checks
-	const size_t hdr_len = headersEnd(buf->content(), buf->contentSize());
-	if (hdr_len <= 0) {
-		debugs(58, 3, "HttpReply::parse: failed to find end of headers " <<
-			"(eof: " << eof << ") in '" << buf->content() << "'");
-		if (eof) // iff we have seen the end, this is an error
-			*error = HTTP_INVALID_HEADER;
-		return false;
-	}
+bool HttpReply::parse(MemBuf *buf, bool eof, http_status *error)
+{
+    assert(error);
+    *error = HTTP_STATUS_NONE;
+
+    // httpReplyParseStep() and debugging require 0-termination, unfortunately
+    buf->terminate(); // does not affect content size
+
+    // quick check that the response starts with HTTP/ or similar
+    // TODO: Remove? Are we optimizing an unusual case or obscure security?
+
+    if (buf->contentSize() >= protoPrefix.size() &&
+            protoPrefix.cmp(buf->content(), protoPrefix.size()) != 0) {
+        debugs(58, 3, "HttpReply::parse: missing protocol prefix (" <<
+               protoPrefix.buf() << ") in '" << buf->content() << "'");
+        *error = HTTP_INVALID_HEADER;
+        return false;
+    }
+
+    // find the end of headers
+    // TODO: Remove? httpReplyParseStep() should do similar checks
+    const size_t hdr_len = headersEnd(buf->content(), buf->contentSize());
+
+    if (hdr_len <= 0) {
+        debugs(58, 3, "HttpReply::parse: failed to find end of headers " <<
+               "(eof: " << eof << ") in '" << buf->content() << "'");
 
-	// TODO: move to httpReplyParseStep()
+        if (eof) // iff we have seen the end, this is an error
+            *error = HTTP_INVALID_HEADER;
+
+        return false;
+    }
+
+    // TODO: move to httpReplyParseStep()
     if (hdr_len > Config.maxReplyHeaderSize) {
-		debugs(58, 1, "HttpReply::parse: Too large reply header (" <<
-			hdr_len << " > " << Config.maxReplyHeaderSize);
-		*error = HTTP_HEADER_TOO_LARGE;
-		return false;
-	}
-
-	const int res = httpReplyParseStep(this, buf->content(), eof);
-	if (res < 0) { // error
-		debugs(58, 3, "HttpReply::parse: cannot parse isolated headers " <<
-			"in '" << buf->content() << "'");
-		*error = HTTP_INVALID_HEADER;
-		return false;
-	}
-
-	if (res == 0) {
-		debugs(58, 2, "HttpReply::parse: strange, need more data near '" <<
-			buf->content() << "'");
-		return false; // but this should not happen due to headersEnd() above
-	}
-
-	assert(res > 0);
-	debugs(58, 9, "HttpReply::parse success (" << hdr_len << " bytes) " <<
-		"near '" << buf->content() << "'");
-	if (hdr_sz != (int)hdr_len) {
-		debugs(58, 1, "internal HttpReply::parse vs. headersEnd error: " <<
-			hdr_sz << " != " << hdr_len);
-		hdr_sz = (int)hdr_len; // because old http.cc code used hdr_len
-	}
-	
-	return true;
+        debugs(58, 1, "HttpReply::parse: Too large reply header (" <<
+               hdr_len << " > " << Config.maxReplyHeaderSize);
+        *error = HTTP_HEADER_TOO_LARGE;
+        return false;
+    }
+
+    const int res = httpReplyParseStep(this, buf->content(), eof);
+
+    if (res < 0) { // error
+        debugs(58, 3, "HttpReply::parse: cannot parse isolated headers " <<
+               "in '" << buf->content() << "'");
+        *error = HTTP_INVALID_HEADER;
+        return false;
+    }
+
+    if (res == 0) {
+        debugs(58, 2, "HttpReply::parse: strange, need more data near '" <<
+               buf->content() << "'");
+        return false; // but this should not happen due to headersEnd() above
+    }
+
+    assert(res > 0);
+    debugs(58, 9, "HttpReply::parse success (" << hdr_len << " bytes) " <<
+           "near '" << buf->content() << "'");
+
+    if (hdr_sz != (int)hdr_len) {
+        debugs(58, 1, "internal HttpReply::parse vs. headersEnd error: " <<
+               hdr_sz << " != " << hdr_len);
+        hdr_sz = (int)hdr_len; // because old http.cc code used hdr_len
+    }
+
+    return true;
 }
Index: squid3/src/HttpReply.h
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/HttpReply.h,v
retrieving revision 1.8.10.2
retrieving revision 1.8.10.3
diff -u -r1.8.10.2 -r1.8.10.3
--- squid3/src/HttpReply.h	25 Aug 2005 21:09:55 -0000	1.8.10.2
+++ squid3/src/HttpReply.h	26 Aug 2005 20:28:41 -0000	1.8.10.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpReply.h,v 1.8.10.2 2005/08/25 21:09:55 rousskov Exp $
+ * $Id: HttpReply.h,v 1.8.10.3 2005/08/26 20:28:41 dwsquid Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -89,13 +89,13 @@
     MEMPROXY_CLASS(HttpReply);
     HttpReply();
 
-	// returns true on success
-	// returns false and sets *error to zero when needs more data
-	// returns false and sets *error to a positive http_status code on error
-	bool parse(MemBuf *buf, bool eof, http_status *error);
+    // returns true on success
+    // returns false and sets *error to zero when needs more data
+    // returns false and sets *error to a positive http_status code on error
+    bool parse(MemBuf *buf, bool eof, http_status *error);
 
     /* Unsupported, writable, may disappear/change in the future
-	 * Sums _stored_ status-line, headers, and <CRLF>.
+    * Sums _stored_ status-line, headers, and <CRLF>.
      * Also used to report parsed header size if parse() is successful */
     int hdr_sz;
 
@@ -118,7 +118,7 @@
     HttpHeader header;
     HttpBody body;		/* for small constant memory-resident text bodies only */
 
-	String protoPrefix;       // e.g., "HTTP/"
+    String protoPrefix;       // e.g., "HTTP/"
 };
 
 MEMPROXY_CLASS_INLINE(HttpReply)
Index: squid3/src/HttpStatusLine.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/HttpStatusLine.cc,v
retrieving revision 1.3.12.1
retrieving revision 1.3.12.2
diff -u -r1.3.12.1 -r1.3.12.2
--- squid3/src/HttpStatusLine.cc	24 Aug 2005 06:09:57 -0000	1.3.12.1
+++ squid3/src/HttpStatusLine.cc	26 Aug 2005 20:28:41 -0000	1.3.12.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpStatusLine.cc,v 1.3.12.1 2005/08/24 06:09:57 rousskov Exp $
+ * $Id: HttpStatusLine.cc,v 1.3.12.2 2005/08/26 20:28:41 dwsquid Exp $
  *
  * DEBUG: section 57    HTTP Status-line
  * AUTHOR: Alex Rousskov
@@ -84,8 +84,9 @@
     assert(sline);
     sline->status = HTTP_INVALID_HEADER;	/* Squid header parsing error */
 
-	// XXX: HttpReply::parse() has a similar check but is using
-	// casesensitive comparison (which is required by HTTP errata?)
+    // XXX: HttpReply::parse() has a similar check but is using
+    // casesensitive comparison (which is required by HTTP errata?)
+
     if (protoPrefix.caseCmp(start, protoPrefix.size()) != 0)
         return 0;
 
Index: squid3/src/HttpStatusLine.h
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/HttpStatusLine.h,v
retrieving revision 1.1.16.1
retrieving revision 1.1.16.2
diff -u -r1.1.16.1 -r1.1.16.2
--- squid3/src/HttpStatusLine.h	24 Aug 2005 06:09:57 -0000	1.1.16.1
+++ squid3/src/HttpStatusLine.h	26 Aug 2005 20:28:41 -0000	1.1.16.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpStatusLine.h,v 1.1.16.1 2005/08/24 06:09:57 rousskov Exp $
+ * $Id: HttpStatusLine.h,v 1.1.16.2 2005/08/26 20:28:41 dwsquid Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -56,8 +56,8 @@
 SQUIDCEXTERN const char *httpStatusLineReason(const HttpStatusLine * sline);
 /* parse/pack */
 /* parse a 0-terminating buffer and fill internal structires; returns true on success */
-SQUIDCEXTERN int httpStatusLineParse(HttpStatusLine * sline, const String &protoPrefix, 
-									 const char *start, const char *end);
+SQUIDCEXTERN int httpStatusLineParse(HttpStatusLine * sline, const String &protoPrefix,
+                                     const char *start, const char *end);
 /* pack fields using Packer */
 SQUIDCEXTERN void httpStatusLinePackInto(const HttpStatusLine * sline, Packer * p);
 
